/* Pelda 08/03 */

/**
 * Lancolt listat megvalosito osztaly.
 *
 * @author Akos Kiss
 */
public class Lista {

    /**
     * Belso osztaly. Csak implementacio. Kivulrol nem kell latni.
     */
    private static class Elem {
        /** A listaelemben tarolt adat. */
	public Object adat;
	/** A kovetkezo listaelem. */
	public Elem kov;
	/** Konstruktor az egyszerubb hasznalathoz. */
	public Elem(Object a, Elem k) {
	    adat = a;
	    kov = k;
	}
    }
    
    /** A lista elso eleme. */
    private Elem fej;

    /** Ures lista letrehozasa. */
    public Lista() {
	fej = null;
    }
    
    /** Uj adat beszurasa a lista elejere. */
    public void beszur(Object o) {
	fej = new Elem(o, fej);
    }

    /**
     * Megallapitja, hogy a lista tartalmazza-e az atadott adatot.
     *
     * @param o a keresendo adat
     * @return true ha a lista tartalmazza az adatot, false egyebkent.
     */
    public boolean tartalmaz(Object o) {
	for (Elem i = fej; i != null; i = i.kov)
	    if (i.adat == null) {
		if (o == null)
		    return true;
	    }
	    else if (i.adat.equals(o)) // == helyett equals!
		return true;
	return false;
    }

}
